// $Id: ADMvar.h,v 1.1 1996/09/23 16:10:02 haupt Exp haupt $

#define MAX_TEMPS 58

class ADMvar {

public:

int ncomponents;

};

class ADMscalar: public ADMvar{

public:
GridFunction(DIM)<double> *spacetime[1];
  
  ADMscalar (GridHierarchy &X, int SpaceStensil, int TimeStensil) {
   int igf;
    
   ncomponents=1;
   spacetime[0]= new GridFunction(DIM)<double>("",TimeStensil,SpaceStensil,
                     X,DAGHCommFaceOnly,DAGHHasShadow);
//    SetTimeAlias(*spacetime[0],1,-1);
  
  }; 

  ADMscalar (GridHierarchy &X, int SpaceStensil) {
   int igf;
   int TimeStensil;
    
   ncomponents=1;
   TimeStensil=0;
   spacetime[0]= new GridFunction(DIM)<double>("",TimeStensil,SpaceStensil,
                     X,DAGHCommFaceOnly,DAGHHasShadow);
  
  }; 

};



class ADMvector: public ADMvar{

public:

GridFunction(DIM)<double> *spacetime[3];
  
  ADMvector (GridHierarchy &X, int SpaceStensil, int TimeStensil) {
   int igf;
    
   ncomponents=3;
   for (igf=0;igf<3;igf++) {
     spacetime[igf]= new GridFunction(DIM)<double>("",TimeStensil,SpaceStensil,
                     X,DAGHCommFaceOnly,DAGHHasShadow);
//     SetTimeAlias(*spacetime[igf],1,-1);
    };

     GridFunction(DIM)<double> &st =*spacetime[0];
  }; 

  ADMvector (GridHierarchy &X, int SpaceStensil) {
   int igf;
   int TimeStensil;
    
   ncomponents=3;
   TimeStensil=0;
   for (igf=0;igf<3;igf++) {
     spacetime[igf]= new GridFunction(DIM)<double>("",TimeStensil,
     SpaceStensil,X,DAGHCommFaceOnly,DAGHHasShadow);
    };
   }; 
   
};

class ADMstensor: public ADMvar{

public:

GridFunction(DIM)<double> *spacetime[6];
  
  ADMstensor (GridHierarchy &X, int SpaceStensil, int TimeStensil ) {
   int igf;
    
   ncomponents=6;
   for (igf=0;igf<ncomponents;igf++) {
     spacetime[igf]= new GridFunction(DIM)<double>("",TimeStensil,
     SpaceStensil,X,DAGHCommFaceOnly,DAGHHasShadow);
//     SetTimeAlias(*spacetime[igf],1,-1);
    };

  }; 

  ADMstensor (GridHierarchy &X, int SpaceStensil) {
   int igf;
    
   ncomponents=6;
   int TimeStensil=0;
   for (igf=0;igf<ncomponents;igf++) {
     spacetime[igf]= new GridFunction(DIM)<double>("",TimeStensil,
     SpaceStensil,X,DAGHCommFaceOnly,DAGHHasShadow);
    };
  };

  ADMstensor (GridFunction(DIM)<double> *d1, GridFunction(DIM)<double> *d2, 
             GridFunction(DIM)<double> *d3, GridFunction(DIM)<double> *d4, 
             GridFunction(DIM)<double> *d5, GridFunction(DIM)<double> *d6) {
  spacetime[0]=d1;
  spacetime[1]=d2;
  spacetime[2]=d3;
  spacetime[3]=d4;
  spacetime[4]=d5;
  spacetime[5]=d6;
  }; 

};

class ADMtensor: public ADMvar{

public:

GridFunction(DIM)<double> *spacetime[9];
  
  ADMtensor (GridHierarchy &X, int SpaceStensil, int TimeStensil ) {
   int igf;
    
   ncomponents=9;
   for (igf=0;igf<ncomponents;igf++) {
     spacetime[igf]= new GridFunction(DIM)<double>("",TimeStensil,
     SpaceStensil,X,DAGHCommFaceOnly,DAGHHasShadow);
//     SetTimeAlias(*spacetime[igf],1,-1);
    };

  }; 

  ADMtensor (GridHierarchy &X, int SpaceStensil) {
   int igf;
    
   ncomponents=9;
   int TimeStensil=0;
   for (igf=0;igf<ncomponents;igf++) {
     spacetime[igf]= new GridFunction(DIM)<double>("",TimeStensil,
     SpaceStensil,X,DAGHCommFaceOnly,DAGHHasShadow);
    };
  };

  ADMtensor (GridFunction(DIM)<double> *d1, GridFunction(DIM)<double> *d2, 
             GridFunction(DIM)<double> *d3, GridFunction(DIM)<double> *d4, 
             GridFunction(DIM)<double> *d5, GridFunction(DIM)<double> *d6, 
             GridFunction(DIM)<double> *d7, GridFunction(DIM)<double> *d8, 
             GridFunction(DIM)<double> *d9) {
  spacetime[0]=d1;
  spacetime[1]=d2;
  spacetime[2]=d3;
  spacetime[3]=d4;
  spacetime[4]=d5;
  spacetime[5]=d6;
  spacetime[6]=d7;
  spacetime[7]=d8;
  spacetime[8]=d9;
  }; 

};

class ADMctensor: public ADMvar{

public:

GridFunction(DIM)<double> *spacetime[18];
  
  ADMctensor (GridHierarchy &X, int SpaceStensil) {
   int igf;
   int TimeStensil;
    
   ncomponents=18;
   TimeStensil=0;
   for (igf=0;igf<ncomponents;igf++) {
     spacetime[igf]= new GridFunction(DIM)<double>("",TimeStensil,
     SpaceStensil,X,DAGHCommFaceOnly,DAGHHasShadow);
    };
  }; 
   
};

class ADMvector1d: public ADMvar{

public:

GridFunction(1)<double> *spacetime[3];
  
  ADMvector1d (GridHierarchy &X) {
   int igf;
   int TimeStensil, SpaceStensil;
    
   ncomponents=3;
   TimeStensil=1;
   SpaceStensil=1;
   for (igf=0;igf<3;igf++) {
     spacetime[igf]= new GridFunction(1)<double>("",TimeStensil,
     SpaceStensil,X,DAGHCommFaceOnly,DAGHHasShadow);
    };
  }; 
   
};

class ADMtemp: public ADMvar{

   int in_use[MAX_TEMPS];

public:
   int num_used, max_used;
   GridFunction(3)<double> *spacetime[MAX_TEMPS];

  ADMtemp (GridHierarchy &X, int SpaceStensil) {
   int igf;
   int TimeStensil;
   int i;
    
   ncomponents=MAX_TEMPS;
   TimeStensil=0;
   for (igf=0;igf<ncomponents;igf++) {
     spacetime[igf]= new GridFunction(DIM)<double>("",TimeStensil,
     SpaceStensil,X,DAGHCommFaceOnly,DAGHHasShadow);
     in_use[igf]=0;
    };
   }; 


int setelement() {
  int i,element;
  
  for(i=0;i<MAX_TEMPS;i++) {
   element=i;
   if(in_use[i]==0) break;
  };
  if(element==MAX_TEMPS-1) {
    cout << "no more temporaries are available" << endl << flush;
    exit(0);
  };
  in_use[i]=1;
  num_used++;
  if(num_used > max_used) {
       max_used=num_used;
  };
  return element;
};

void freeelement(int i) {
   in_use[i]=0;
   num_used--;
};

void printtemps(char* s) {
   cout << s << " " << "Ntemps = " << num_used << " " << max_used << endl
   << flush;
};

};   

class TMPscalar: public ADMvar{

public:
GridFunction(DIM)<double> *spacetime[1];
int tmp_element;
ADMtemp *pool;
  
  TMPscalar (ADMtemp *tmp) {
    pool=tmp;
    tmp_element=(*tmp).setelement();
    spacetime[0] = (*tmp).spacetime[tmp_element]; 
  };

  ~TMPscalar() {
   (*pool).freeelement(tmp_element); 
  };
};

class TMPvector: public ADMvar{

public:
GridFunction(DIM)<double> *spacetime[3];
int tmp_element[3];
int i;
ADMtemp *pool;
  
  TMPvector(ADMtemp *tmp) {

    ncomponents=3;
    pool=tmp;
    for (i=0;i<ncomponents;i++) {  
       tmp_element[i]=(*tmp).setelement();
       spacetime[i] = (*tmp).spacetime[tmp_element[i]]; 
    };
  };

  ~TMPvector() {

    for (i=0;i<ncomponents;i++) {  
        (*pool).freeelement(tmp_element[i]);
    }; 
  };
};

class TMPstensor: public ADMvar{

public:
GridFunction(DIM)<double> *spacetime[6];
int tmp_element[6];
int i;
ADMtemp *pool;
  
  TMPstensor (ADMtemp *tmp) {

    ncomponents=6;
    pool=tmp;
    for (i=0;i<ncomponents;i++) {  
       tmp_element[i]=(*tmp).setelement();
       spacetime[i] = (*tmp).spacetime[tmp_element[i]]; 
    };
  };

  ~TMPstensor() {

    for (i=0;i<ncomponents;i++) {  
        (*pool).freeelement(tmp_element[i]);
    }; 
  };
};


class TMPrtensor: public ADMvar{

public:
GridFunction(DIM)<double> *spacetime[6];
int tmp_element[6];
int i;
ADMtemp *pool;
  
  TMPrtensor (ADMtemp *tmp) {

    ncomponents=6;
    pool=tmp;
    for (i=0;i<ncomponents;i++) {  
       tmp_element[i]=(*tmp).setelement();
       spacetime[i] = (*tmp).spacetime[tmp_element[i]]; 
    };
  };

  ~TMPrtensor() {

    for (i=0;i<ncomponents;i++) {  
        (*pool).freeelement(tmp_element[i]);
    }; 
  };
};

class TMPtensor: public ADMvar{

public:
GridFunction(DIM)<double> *spacetime[9];
int tmp_element[9];
int i;
ADMtemp *pool;
  
  TMPtensor (ADMtemp *tmp) {

    ncomponents=9;
    pool=tmp;
    for (i=0;i<ncomponents;i++) {  
       tmp_element[i]=(*tmp).setelement();
       spacetime[i] = (*tmp).spacetime[tmp_element[i]]; 
    };
  };

  ~TMPtensor() {

    for (i=0;i<ncomponents;i++) {  
        (*pool).freeelement(tmp_element[i]);
    }; 
  };
};

class TMPctensor: public ADMvar{

public:
GridFunction(DIM)<double> *spacetime[18];
int tmp_element[18];
int i;
ADMtemp *pool;
  
  TMPctensor (ADMtemp *tmp) {

    ncomponents=18;
    pool=tmp;
    for (i=0;i<ncomponents;i++) {  
       tmp_element[i]=(*tmp).setelement();
       spacetime[i] = (*tmp).spacetime[tmp_element[i]]; 
    };
  };

  ~TMPctensor() {

    for (i=0;i<ncomponents;i++) {  
        (*pool).freeelement(tmp_element[i]);
    }; 
  };
};



